#include "C:\\projects\\Flame\\Flame_Auto.h"
#include <maths.h>

void T1Overflow();

BYTE	Target[8];	//array of random target values
BYTE	Present[8];	//array of present PWM values
char	Direction[8]; //array of directions from Present to Target value
BYTE	PwmOffCounter; //counter reset each PWM frame


//*******************************************************************************


void UserInterrupt()
{
  if (PIR1&(1<<TMR1IF))		// Timer 1 overflow
  {
  	PIR1&=~(1<<TMR1IF);
		TMR1H = 0xF6;
		TMR1L = 0x4C;
   	T1Overflow();
  }


 #asmline SETPCLATH UserIntReturn,-1  ; SETPCLATH for interrupt routine
 #asmline goto UserIntReturn	      ; Assembler - go back to interrupt routine
}


//*******************************************************************************


void UserInitialise()
{
	srand(TMR0);
	//start with random values and the directions set up
	for(BYTE i = 0; i < 8; i++) 
	{
		Target[i] = (BYTE)(rand() & 0xFF);
		Present[i] = (BYTE)(rand() & 0xFF);
		Direction[i] = 0;
		Direction[i] = Target[i] > Present[i] ? 1 : -1;
	}

	// initial values for timer
	TMR1H = 0xF6;
	TMR1L = 0x4C;

}

//*******************************************************************************


void UserLoop()
{
	BYTE i;
	
	PwmOffCounter++;
	
	for(i = 0; i < 8; i++) 
	{
		if(PwmOffCounter > Present[i]) PORTB &= ~(1 << i);
	}
		
	if(PwmOffCounter == 0)
	{
		PORTB = 0xFF;
	}
}

//*******************************************************************************


//*******************************************************************************
// 50 times per second PWM variation rate
void T1Overflow() 
{
	BYTE i;
	
	TMR1H = 0x00;
	TMR1L = 0xC3;
	
//PORTB = 0xFF;		//start new cycle with all bits ON

	for(i = 0; i < 8; i++)
	{
		Present[i] += Direction[i]; //move toward target
		if(Present[i] == Target[i])
		{
			Target[i] = (BYTE) (rand() & 0xFF);
			Direction[i] = Target[i] > Present[i] ? 1 : -1;
		}
	}
}
